package etusivu;


import java.io.PrintStream;
import java.net.URL;
import java.util.List;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.StringGrid;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.scene.text.Font;
import reittiLoki.Halli;
import reittiLoki.Reittiloki;
import reittiLoki.SailoException;
import reittiLoki.Suoritus;
import javafx.scene.control.ScrollPane;

/**
 * @author OMISTAJA
 * @version 31.1.2025
 *
 */
public class HtGUIController implements Initializable {
    @FXML private MenuItem fxLisaaHalli;
    @FXML private Button fxLisaaSuoritus;
    @FXML private ListView<?> fxListaus;
    @FXML private Button fxMuokkaaSuoritus;
    @FXML private MenuItem fxPeruuta;
    @FXML private MenuItem fxSulje;
    @FXML private ListView<?> fxSuoritus;
    @FXML private StringGrid<Halli> fxhallit;

    @FXML private MenuItem fxTietoja;
    @FXML private ListChooser<Suoritus> chooserSuoritukset;
    @FXML private ScrollPane panelSuoritus;
    @FXML private MenuItem fxPoista;
    @FXML private TextField fxHaku;
    @FXML private Button fxhakuNappi;
    
    @FXML void mLisaa(ActionEvent event) {
       uusiSuoritus();
    }
    
    @FXML void MuokkaaSuoritusta(MouseEvent event) {
        muokkaa();
    }
    
    @FXML void mPoistaSuoritus(ActionEvent event) {
        poista();
    }


    @FXML void mHallinLisays(ActionEvent event) {
        uusiHalli();
    }

    @FXML void mPeruuta(ActionEvent event) {
        Lisaa();
    }

    @FXML void mSulje(ActionEvent event) {
        try {
            loki.tallenna("data");
        } catch (SailoException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        System.exit(0);

    }
    
    @FXML void suoritaHaku() {
        String ehto = fxHaku.getText();
        hae(0, ehto);
    }

    @FXML void mTiedot(ActionEvent event) {
        Lisaa();
    }
    
    @Override
    public void initialize(URL arg0, ResourceBundle arg1) {
        alusta();
        
    }


//-------------------------------------------------------------------------------

    private Reittiloki loki;
    private TextArea areaSuoritus = new TextArea();
    
    private void alusta() {
        panelSuoritus.setContent(areaSuoritus);
        areaSuoritus.setFont(new Font("Times new Roman", 12));
        panelSuoritus.setFitToHeight(true);
        chooserSuoritukset.clear();
        chooserSuoritukset.addSelectionListener(e -> naytaSuoritus());
        
        fxhallit.setPlaceholder(new Label("Ei vielä halleja"));
        String[] headings = {"Nimi","Osoite","SuoritusNro"};
        fxhallit.initTable(headings);
        fxhallit.setEditable(false);
        
    }
    
    private void Lisaa() {
        Alert alert = new Alert(AlertType.INFORMATION);
         alert.setTitle("Huomautus");
         alert.setHeaderText(null);
          alert.setContentText("Toiminta tulossa");
         alert.showAndWait();
}
    
    private void poista() {       
       Suoritus kohdalla = chooserSuoritukset.getSelectedObject();
       loki.poista(kohdalla);
       hae(0);
    }
    
    
    
    private void naytaHallit(Suoritus suoritus) {
        fxhallit.clear();
        if(suoritus == null) return; 
        
        List<Halli> hallit = loki.annaHallit(suoritus);
        if (hallit.size() == 0) return;
        for (Halli ha: hallit)
            naytaHalli(ha);
    }
    
    /**
     * Pilkkoo ja lisää hallin String gridin kenttiin.
     * @param ha Lisattava halli.
     */
    private void naytaHalli(Halli ha) {
        String[] rivi = ha.toString().split("|");
        String sana = "";
        for (int i = 0, k = 0; i < rivi.length; i++) {
            if (rivi[i].equals("|")) {
                rivi[k] = sana;
                k++;
                sana = "";
                continue;
            }
            sana += rivi[i];
            
        }  
        rivi[3] = sana;                                  
        fxhallit.add(ha,rivi[1],rivi[2],rivi[3]);        //TODO Vähän mielenkiintonen toteutus. Voidaan parantaa jatkossa.
    }
    

    private void naytaSuoritus() {
        Suoritus kohdalla = chooserSuoritukset.getSelectedObject();
        
        if (kohdalla == null) return;
        

        areaSuoritus.setText("");
        
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(areaSuoritus)){
               kohdalla.tulosta(os); 
    }
        naytaHallit(kohdalla);
    
}
    
    /**
     * @param loki Valitaan tiedosto jota käytetään.
     */
    public void setReittiloki(Reittiloki loki) {
        this.loki= loki;
        try {
            loki.lueTiedostosta("data");
        } catch (SailoException e) {
            Dialogs.showMessageDialog(e.getMessage());
            e.printStackTrace();
        }
        hae(0);
}
    /**
     * Haetaan kaikki mahdolliset suoritukset. Aliohjelma suoritetaan ohjelmaa aukastaessa.
     * @param sNro hakee suorituksen numeron.
     */
    public void hae(int sNro) {
        chooserSuoritukset.clear();
        
        int index = 0;
        for (int i= 0; i < loki.getSuorituksia(); i++) {
            Suoritus suoritus = loki.annaSuoritus(i);
            if(suoritus.getId() == sNro) index = i;
            chooserSuoritukset.add(" "+ suoritus.getNimi(), suoritus);
        }
        chooserSuoritukset.setSelectedIndex(index);
    }
    
    /**
     * Haetaan suorituksia suodattamalla hakuehdolla.
     * @param sNro Haettavan suorituksen nro. Toimii oletuksena niin että haetaan kaikki 0 id:stä eteenpäin.
     * @param ehto Sana jolla sisältöä suodatetaan.
     */
    public void hae(int sNro, String ehto) {
        chooserSuoritukset.clear();
        
        int index = 0;
        for (int i= 0; i < loki.getSuorituksia(); i++) {
            Suoritus suoritus = loki.annaSuoritus(i);
            if(suoritus.getId() == sNro) index = i;
            if(suoritus.getNimi().contains(ehto))chooserSuoritukset.add(" "+ suoritus.getNimi(), suoritus);
        }
        chooserSuoritukset.setSelectedIndex(index);
    }
    private void uusiSuoritus() {
        Suoritus uusi = new Suoritus();
        uusi = ModalController.showModal(SuoritusGUIController.class.getResource("SuoritusGUIView.fxml"), "Suoritus", null, uusi);
       if(uusi == null) return;
           try {
           loki.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden Suorituksen luonnissa: " + e.getMessage());
        }
        uusi.rekisteroi();
        hae(uusi.getId());
        try {
            loki.tallenna("data");
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelmia uuden Suorituksen luonnissa: " + e.getMessage());
            e.printStackTrace();
        }
    }
    
    /**
     * Valitun suorituksen muokkaaminen
     */
    private void muokkaa() {
        Suoritus suoritusKohdalla = chooserSuoritukset.getSelectedObject();
        if (suoritusKohdalla == null) return;
        Suoritus suoritus;
        try {
            suoritus = suoritusKohdalla.clone();
            suoritus = SuoritusGUIController.kysySuoritus(null, suoritus);
            if(suoritus == null) return;
            loki.korvaaLisaa(suoritus);
            hae(suoritusKohdalla.getId());
        } catch (CloneNotSupportedException e) {
            // TODO Ei osata tehä mittää.
            e.printStackTrace();
        }        
        
    }
    
    
    private void uusiHalli() {
        Suoritus suoritusKohdilla = chooserSuoritukset.getSelectedObject();
        if(suoritusKohdilla == null) return;
        Halli ha = new Halli();
        ModalController.showModal(HalliGUIController.class.getResource("HalliGUIView.fxml"), "Hallin lisäys", null, ha);
        ha.rekisteroi();
        ha.getNimi();
        ha.getOsoite();
        ha.setSuoritusNro(suoritusKohdilla.getId());
        loki.lisaa(ha);
        hae(suoritusKohdilla.getId());
    }
    
}