package etusivu;

import java.net.URL;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
import reittiLoki.Suoritus;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Label;

/**
 * @author OMISTAJA
 * @version 31.1.2025
 *
 */
    public class SuoritusGUIController implements ModalControllerInterface <Suoritus>, Initializable {

        @FXML private TextField fxHalli;
        @FXML private TextField fxKiipeilytyyli;
        @FXML private TextField fxKommentti;
        @FXML private TextField fxNimi;
        @FXML private Button fxPeruuta;
        @FXML private TextField fxReitinTyyppi;
        @FXML private TextField fxSuoritusPaiva;
        @FXML private Button fxTallenna;
        @FXML private TextField fxVaikeusaste;
        @FXML private TextField fxYritystenMaara;
        @FXML private Label labelVirhe;
        @FXML private Label fxPakollinen;
        
        
        /**
         * Suorituksen tallenna painike.
         */
        @FXML private void eTallenna() {
            if (suoritusKohdalla != null && suoritusKohdalla.getNimi().trim().equals("")) {
                virheTila("Nimi ei saa olla tyhjä.");
                return;
            }
            tallennetaan = true;
            ModalController.closeStage(fxNimi);
        }
        
        /**
         * Suorituksen peruuta painike.
         */
        @FXML private void ePeruuta() {
           tallennetaan = false;
           //suoritusKohdalla = null;
           ModalController.closeStage(fxNimi);
        }
        
//------------------------------------------------------------------------------
    
    private Suoritus suoritusKohdalla;
    private boolean tallennetaan = false;
    
    private void virheTila(String virhe) {
        fxTallenna.disarm();
        fxPakollinen.setText(virhe);
        }

    
    /**
     * Ilmottaa jos jonkin toiminnallisuuden kehitys on vielä kesken.
     */
    private void Kesken() {
        Alert alert = new Alert(AlertType.INFORMATION);
        alert.setTitle("Huomautus");
        alert.setHeaderText(null);
        alert.setContentText("Toiminta tulossa");
        alert.showAndWait();
    }

    @Override
    public Suoritus getResult() {
        if(tallennetaan) return suoritusKohdalla;
        
        return null;
    }

    @Override
    public void handleShown() {
        alusta();
        
    }

    @Override
    public void setDefault(Suoritus oletus) {
        suoritusKohdalla = oletus;
        naytaSuoritus(suoritusKohdalla);
    }

    @Override
    public void initialize(URL arg0, ResourceBundle arg1) {
        // TODO Auto-generated method stub
        
    }
    
    /**
     * Avaa suorituksen tiedot modaaliin.
     * @param mStage Avattava modaali.
     * @param oletus Oletus tiedot, joilla modaali täytetään.
     * @return Suoritus
     */
    public static Suoritus kysySuoritus(Stage mStage, Suoritus oletus) {
       return  ModalController.showModal(HtGUIController.class.getResource("SuoritusGUIView.fxml"), "Suoritus", mStage, oletus);
        
    }
        
    private void naytaSuoritus(Suoritus suoritusK) {
        if (suoritusK == null) return;
        fxNimi.setText(suoritusK.getNimi());
        fxHalli.setText(suoritusK.getHalli());
        fxKiipeilytyyli.setText(suoritusK.getKiipeilyTyyli());
        fxKommentti.setText(suoritusK.getKommentti());
        fxReitinTyyppi.setText(suoritusK.getTyyppi());
        fxSuoritusPaiva.setText(suoritusK.getPaiva());
        fxVaikeusaste.setText(suoritusK.getVaikeus());
        fxYritystenMaara.setText(suoritusK.getMaara());
    }
    
    private void alusta() {
        fxNimi.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxNimi,0));
        fxHalli.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxHalli,1));
        fxKiipeilytyyli.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxKiipeilytyyli,2));
        fxKommentti.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxKommentti,3));
        fxReitinTyyppi.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxReitinTyyppi,4));
        fxSuoritusPaiva.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxSuoritusPaiva,5));
        fxVaikeusaste.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxVaikeusaste,6));
        fxYritystenMaara.setOnKeyReleased(e -> kasitteleSuoritusMuutos(fxYritystenMaara,7));
    }
    
    
    private void kasitteleSuoritusMuutos(TextField muokkaus, int kentta) {
        if (suoritusKohdalla == null) return;
        String s = muokkaus.getText();
 
        switch (kentta) {
        case 0:
            suoritusKohdalla.setNimi(s);
          break;
        case 1:
            suoritusKohdalla.setHalli(s);
          break;
        case 2:
            suoritusKohdalla.setTyyli(s);
          break;
        case 3:
            suoritusKohdalla.setKommentti(s);
          break;
        case 4:
            suoritusKohdalla.setTyyppi(s);
          break;
        case 5:
            suoritusKohdalla.setPvm(s);
          break;
        case 6:
            suoritusKohdalla.setVaikeus(s);
          break;
        case 7:
            suoritusKohdalla.setYritykset(s);
          break;
        default:
            break;
      }

        } 
    } 