package reittiLoki;

import java.io.PrintStream;

import fi.jyu.mit.ohj2.Mjonot;

/**
 * @author OMISTAJA
 * @version 28.2.2025
 *
 */
public class Suoritus implements Cloneable {
    
    private int id = 0;
    private String nimi = "";
    private String vaikeusAste = "";
    private String kiipeilyTyyli = "";
    private String reitinTyyppi = "";
    private String suoritusPvm = "";
    private String yrityksia = "0";
    private String halli = "";
    private String kommentti = "";
    private boolean lisataan = false;
    
    private static int seuraavaNro = 1;
    
    
    /**
     * Alustaa Suorituksen tiedot.
     */
    public Suoritus() {
        
    }
    
    /**
     * Tehdään klooni Suorituksesta.
     * @return kloonattu object Suorituksesta.
     */
    @Override
    public Suoritus clone() throws CloneNotSupportedException {
        Suoritus uusi;
        uusi = (Suoritus)super.clone();
        return uusi;
    }
      
    
   /**
    * Tulostetaan suorituksen tiedot
    * @param out Minne tulostetaan.
    */
    public void tulosta(PrintStream out) {
       out.println("Id:" + id + " Reitti:" + nimi + " Vaikeus:" + vaikeusAste + " Tyyli:" + kiipeilyTyyli + " Tyyppi:" + reitinTyyppi);
       out.println("Pvm:" + suoritusPvm + " yrityksia:" + yrityksia + " halli:" + halli);
       out.println("kommentti:" + kommentti);
       out.println();
   }
    
    /**
     * Palauttaa suorituksen Id:n.
     * @return Suorituksen Id.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getId() === 0;
     * </pre>
     */
    public int getId() {
        return id;
    }
    
    /**
     * Aliohjelma antaa suoritukselle seuraavan id:n.
     * @example
     * <pre name="test">
     * Suoritus testi1 = new Suoritus();
     * testi1.getId() === 0;
     * testi1.rekisteroi();
     * Suoritus testi2 = new Suoritus();
     * testi2.rekisteroi();
     * int n1 = testi1.getId();
     * int n2 = testi2.getId();
     * n1 === n2-1;
     * </pre>
     */
    public void rekisteroi() {
        this.id = seuraavaNro;
        seuraavaNro++;
    }
    
    /**
     * Apumetodi, jolla täytetään tiedot suoritukselle. Käytetään testien kanssa ja kehitysvaiheessa.
     * Poistetaan myöhemmin.
     */
    public void taytaSuoritus() {
        
        nimi = "Kattoralli"; //+ tarkistusNro(); Käytetään jos halutaan arpoa numero testi suorituksen nimen perään.
        vaikeusAste = "6B";
        kiipeilyTyyli = "Boulder";
        reitinTyyppi = "Hankki";
        suoritusPvm = "28.02.2025";
        yrityksia = "3";
        halli = "Ristikko";
        kommentti = "Kyllä o heleppoa!";
    }
    
    /**
     * Tarkistusnumeroa käytetään vain varmistamaan että suoritukset eroavat toisistaan. Poistetaan kehityksen jälkeen tarvittaessa.
     * @return Tarkistusnumero
     */
    public int tarkistusNro() {
        double nro = Math.random() * 100;
        int tulos = (int) nro;
        return tulos;
    }
    
    /**
     * @return palauttaa suorituksen nimen.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getNimi() === "Kattoralli";
     * </pre>
     */
    public String getNimi() {
        return this.nimi;
    }
    
    /**
     * @return Hallin nimi
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getHalli() === "Ristikko";
     * </pre>
     */
    public String getHalli() {
        return this.halli;
        
    }
    
    /**
     * @return Kertoo suorituksen kiipeilytyylin.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getKiipeilyTyyli() === "Boulder";
     * </pre>
     */
    public String getKiipeilyTyyli() {
        return this.kiipeilyTyyli;
        
    }
    
    /**
     * @return Palauttaa suoritukseen liitetyn kommentin.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getKommentti() === "Kyllä o heleppoa!";
     * </pre>
     */
    public String getKommentti() {
        return this.kommentti;
        
    }
    
    /**
     * @return Palauttaa reitin tyypin.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getTyyppi() === "Hankki";
     * </pre>
     */
    public String getTyyppi() {
        return this.reitinTyyppi;
        
    }
    
    /**
     * @return Suorituspäivä
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getPaiva() === "28.02.2025";
     * </pre>
     */
    public String getPaiva() {
        return this.suoritusPvm;
        
    }
    
    /**
     * @return Palauttaa reitin vaikeusasteen.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getVaikeus() === "6B";
     * </pre>
     */
    public String getVaikeus() {
        return this.vaikeusAste;
        
    }
    
    /**
     * @return Palauttaa yritysten määrän.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.getMaara() === "3";
     * </pre>
     */
    public String getMaara() {
        return this.yrityksia;      
    }
    
    /**
     * Kertoo tallennetaanko suoritus uudeksi.
     * @return tieto siitä lisätäänkö suoritus uudeksi.
     */
    public boolean getLisataan() {
        return this.lisataan;        
    }
    
    /**
     * Kertoo tallennetaanko suoritus uudeksi.
     */
    public void setLisataan() {
        this.lisataan = true;        
    }
    
    /**
     * Asettaa halutun id:n suoritukselle.
     * @param nro asetettava id
     */
    private void setId(int nro) {
        id = nro;
        if(id >= seuraavaNro) seuraavaNro = id +1;
    }
    
    /**
     * @param s uusi nimi
     * @return antaa nullin jos toimii, muuten antaa virheen.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setNimi("Toimii");
     * eka.getNimi() === "Toimii";
     * </pre>
     */
    public String setNimi(String s) {
        this.nimi = s;
        return null;
    }
    
    /**
     * @param s Hallin uusi nimi
     * @return tyhjä
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setHalli("Toimii");
     * eka.getHalli() === "Toimii";
     * </pre>
     */
    public String setHalli(String s) {
        this.halli = s;
        return null;
    }
    
    /**
     * Syöttää tyylin suoritus oliolle.
     * @param s Tyyli kenttään syötettävä merkkijono
     * @return String merkkijono.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setTyyli("Toimii");
     * eka.getKiipeilyTyyli() === "Toimii";
     * </pre>
     */
    public String setTyyli(String s) {
        this.kiipeilyTyyli = s;
        return null;
    }

    /**
     * Asettaa suoritukselle kommentin.
     * @param s Merkkijono joka halutaan kommentiksi.
     * @return Kommentti.
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setKommentti("Toimii");
     * eka.getKommentti() === "Toimii";
     * </pre>
     */
    public String setKommentti(String s) {
        this.kommentti = s;
        return null;
    }

    /**
     * Asett suoritukselle reitin tyypin.
     * @param s Suoritukselle syötettävä tyyppi merkkijonona.
     * @return Reitintyppi merkkijono
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setTyyppi("Toimii");
     * eka.getTyyppi() === "Toimii";
     * </pre>
     */
    public String setTyyppi(String s) {
        this.reitinTyyppi = s;
        return null;
    }

    /**
     * Asettaa suoritukselle suoritusajankohdan.
     * @param s suorituspäivämäärä merkkijonona.
     * @return suorituspäivämäärä
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setPvm("Toimii");
     * eka.getPaiva() === "Toimii";
     * </pre>
     */
    public String setPvm(String s) {
        this.suoritusPvm = s;
        return null;
    }

    /**
     * Asettaa suoritukselle vaikeusasteen.
     * @param s Suorituksen vaikeusaste merkkijonona.
     * @return vaikeusaste
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setVaikeus("Toimii");
     * eka.getVaikeus() === "Toimii";
     * </pre>
     */
    public String setVaikeus(String s) {
        this.vaikeusAste = s;
        return null;
    }

    /**
     * Asettaa suoritukseen käytetyn yritysmäärän.
     * @param s suoritukseen käytetty yritysmäärä.
     * @return yritysmäärä
     * @example
     * <pre name="test">
     * Suoritus eka = new Suoritus();
     * eka.taytaSuoritus();
     * eka.setYritykset("5");
     * eka.getMaara() === "5";
     * </pre>
     */
    public String setYritykset(String s) {
        this.yrityksia = s;
        return null;
    }
  
    /**
    * Muuntaa Suorituksen tiedot merkkijonoksi.
    * @example
    * <pre name="test">
    * Suoritus eka = new Suoritus();
    * eka.taytaSuoritus();
    * eka.toString() === "0|Kattoralli|6B|Boulder|Hankki|28.02.2025|3|Ristikko|Kyllä o heleppoa!";
    * </pre>
    */
   @Override
   public String toString() {
       return "" +
               getId() + "|" +
               nimi + "|" +
               vaikeusAste + "|" +
               kiipeilyTyyli + "|" +
               reitinTyyppi + "|" +
               suoritusPvm + "|" +
               yrityksia + "|" +
               halli + "|" +
               kommentti;             
   }
   
   /**
 * @param r Tutkittava rivi
 * @example
 * <pre name="test">
 * Suoritus eka = new Suoritus();
 * String s = "6|Kattoralli 5|6B|Boulder|Hankki|28.02.2025|3|Ristikko|Kyllä o heleppoa!";
 * eka.parse(s);
 * eka.getId() === 6;
 * eka.getNimi() === "Kattoralli 5";
 * eka.getVaikeus() === "6B";
 * eka.getKiipeilyTyyli() === "Boulder";
 * eka.getTyyppi() === "Hankki";
 * eka.getPaiva() === "28.02.2025";
 * eka.getMaara() === "3";
 * eka.getHalli() === "Ristikko";
 * eka.getKommentti() === "Kyllä o heleppoa!";
 * </pre>
 */
public void parse(String r) {
       StringBuilder sb = new StringBuilder(r);
       setId(Mjonot.erota(sb, '|', getId()));
       nimi = Mjonot.erota(sb, '|', nimi);
       vaikeusAste = Mjonot.erota(sb, '|', vaikeusAste);
       kiipeilyTyyli = Mjonot.erota(sb, '|', kiipeilyTyyli);
       reitinTyyppi = Mjonot.erota(sb, '|', reitinTyyppi);
       suoritusPvm = Mjonot.erota(sb, '|', suoritusPvm);
       yrityksia = Mjonot.erota(sb, '|', yrityksia);
       halli = Mjonot.erota(sb, '|', halli);
       kommentti = Mjonot.erota(sb, '|', kommentti);
   }




    /**
     * @param args ei käytössä.
     */
    public static void main(String[] args) {
        
        Suoritus eka = new Suoritus();
        Suoritus toka = new Suoritus();
        
        eka.tulosta(System.out);
        toka.tulosta(System.out);
        
        eka.rekisteroi();
        toka.rekisteroi();
        
        eka.taytaSuoritus();
        toka.taytaSuoritus();
        
        eka.tulosta(System.out);
        toka.tulosta(System.out);
        

    }
}
